'use strict';

var _babelCore = require('babel-core');

var babel = _interopRequireWildcard(_babelCore);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

it('correctly namespaces unqualified define calls', function () {
  var source = '\n\tdefine([], function(){})\n\t';

  var _babel$transform = babel.transform(source, {
    plugins: [_index2.default]
  }),
      code = _babel$transform.code;

  expect(code).toMatchSnapshot();
});

it('does not namespace already qualified define calls', function () {
  var source = '\n\tOther.Namespace.define([], function(){})\n\t';

  var _babel$transform2 = babel.transform(source, {
    plugins: [_index2.default]
  }),
      code = _babel$transform2.code;

  expect(code).toMatchSnapshot();
});

// It is not clear what would be the best way to handle multiple define calls in
// the code.
// On the one hand, it is faster to only change the first appearance as 99% of
// the time we will be processing AMD modules with define calls issued by us.
// On the other hand, some third party modules (like jQuery, for instance) issue
// define() calls inside their code. We expect only one such call, but if
// someone does anything more exotic than that, this plugin could "fail".
it('only namespaces the first appearance of define() in the source', function () {
  var source = '\n\tif(window.define) {\n\t\tdefine([], function() {\n\t\t\tconsole.log(define(\'this should not be namespaced\'));\n\t\t});\n\t}\n\tdefine(\'this should not be namespaced\')\n\t';

  var _babel$transform3 = babel.transform(source, {
    plugins: [_index2.default]
  }),
      code = _babel$transform3.code;

  expect(code).toMatchSnapshot();
});
//# sourceMappingURL=index.test.js.map